<ui:composition
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:g="http://www.ihe.net/gazelle"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core">
    <!-- This page is a template, it should be included into an XHTML page using a ui:decorate element
        required parameter is : managedBean - a backing bean which extends AbstractTransactionInstanceDisplay with scope PAGE
        use ui:define to fill requestContent and responseContent sections -->
    <h:form>
        <s:div id="globalDiv"
               rendered="#{managedBean.selectedInstance != null}">
            <h1>
                <h:outputText
                        value="#{messages['gazelle.simu.TransactionInstanceDetails']} (##{managedBean.selectedInstance.id})"/>
            </h1>
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['gazelle.simu.Metadata']}</ui:define>
                <dl class="dl-horizonal">
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.Timestamp']}</ui:define>
                        <g:date value="#{managedBean.selectedInstance.timestamp}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.SimulatedActor_2']}</ui:define>
                        <h:outputText
                                value="#{managedBean.selectedInstance.simulatedActor.name}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.Domain']}</ui:define>
                        <h:outputText value="#{managedBean.selectedInstance.domain.name}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.Transaction']}</ui:define>
                        <h:outputText
                                value="#{managedBean.selectedInstance.transaction.keyword}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.Initiator']}</ui:define>
                        <h:outputText
                                value="#{managedBean.selectedInstance.request.issuer} (#{managedBean.selectedInstance.request.issuingActor.name})"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.Responder']}</ui:define>
                        <h:outputText
                                value="#{managedBean.selectedInstance.response.issuer} (#{managedBean.selectedInstance.response.issuingActor.name})"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{not empty managedBean.selectedInstance.companyKeyword}">
                        <ui:define name="label">#{messages['net.ihe.gazelle.simulators.CompanysKeyword']}</ui:define>
                        <h:outputText
                                value="#{managedBean.selectedInstance.companyKeyword})"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.PermanentLink']}</ui:define>
                        <a href="#{managedBean.permanentLink(managedBean.selectedInstance)}">#{managedBean.permanentLink(managedBean.selectedInstance)}</a>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simu.PermanentLinkToTestReport']}</ui:define>
                        <a
                                href="#{managedBean.permanentLinkToTestReport(managedBean.selectedInstance)}">#{managedBean.permanentLinkToTestReport(managedBean.selectedInstance)}</a>
                    </s:decorate>
                </dl>
            </ui:decorate>


            <ul class="nav nav-tabs" role="tablist">
                <li role="presentation" class="active">
                    <a href="#requesttab" aria-controls="requesttab" role="tab" data-toggle="tab">#{messages['gazelle.simu.Request_2']}
                        #{managedBean.selectedInstance.request.type}</a>
                </li>
                <li role="presentation">
                    <a href="#responsetab" aria-controls="responsetab" role="tab" data-toggle="tab">#{messages['gazelle.simu.Response_2']}
                        #{managedBean.selectedInstance.response.type}</a>
                </li>
            </ul>

            <div class="tab-content tab-content-with-border">
                <div role="tabpanel" class="tab-pane active" id="requesttab">
                    <f:subview id="reqMetadata">
                        <ui:include src="/messages/messageMetadata.xhtml">
                            <ui:param name="mInstance" value="#{managedBean.selectedInstance.request}"/>
                        </ui:include>
                    </f:subview>
                    <ui:insert name="requestContent"/>
                    <br/>
                    <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
                        <ui:param name="panel_id" value="requestValidationPanel"/>
                        <ui:define name="panel_title">#{messages['gazelle.simu.ValidationResultStatus']}
                            #{managedBean.selectedInstance.request.validationStatus})
                        </ui:define>
                        <h:outputText
                                value="#{managedBean.getPrettyFormattedResult(managedBean.selectedInstance.request)}"
                                escape="false"
                                rendered="#{managedBean.selectedInstance.request.validationStatus != null}"/>
                        <h:outputText rendered="#{managedBean.selectedInstance.request.validationStatus == null}"
                                      value="#{messages['gazelle.simu.ValidationOfTheRequestHasNotBeenPerformedYetOrIs']}"/>
                        <ui:define name="panel_footer">
                            <a4j:commandButton value="#{messages['gazelle.simu.ValidateAgain']}"
                                               actionListener="#{managedBean.validateRequest()}"
                                               styleClass="gzl-btn-blue"
                                               render="requestValidationPanel"/>
                        </ui:define>
                    </ui:decorate>
                </div>
                <div role="tabpanel" class="tab-pane" id="responsetab">
                    <f:subview id="responseMetadata">
                        <ui:include src="/messages/messageMetadata.xhtml">
                            <ui:param name="mInstance" value="#{managedBean.selectedInstance.response}"/>
                        </ui:include>
                    </f:subview>
                    <ui:insert name="responseContent"/>
                    <br/>
                    <s:div rendered="#{managedBean.selectedInstance.response.content != null}">
                        <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
                            <ui:param name="panel_id" value="responseValidationPanel"/>
                            <ui:define name="panel_title">#{messages['gazelle.simu.ValidationResultStatus']}
                                #{managedBean.selectedInstance.response.validationStatus})
                            </ui:define>
                            <h:outputText
                                    value="#{managedBean.getPrettyFormattedResult(managedBean.selectedInstance.response)}"
                                    escape="false"
                                    rendered="#{managedBean.selectedInstance.response.validationStatus != null}"/>
                            <h:outputText rendered="#{managedBean.selectedInstance.response.validationStatus == null}"
                                          value="#{messages['gazelle.simu.ValidationOfTheResponseHasNotBeenPerformedYetOrI']}"/>
                            <ui:define name="panel_footer">
                                <a4j:commandButton value="#{messages['gazelle.simu.ValidateAgain']}"
                                                   actionListener="#{managedBean.validateResponse()}"
                                                   styleClass="gzl-btn-blue"
                                                   render="responseValidationPanel"/>
                            </ui:define>
                        </ui:decorate>
                    </s:div>
                </div>
            </div>
        </s:div>
        <s:div id="unknowninstance"
               rendered="#{managedBean.selectedInstance == null}">
            <h:outputText
                    value="#{messages['gazelle.simu.ThisIdDoesNotReferenceAnyKnownTransactionInstanc']}"
                    styleClass="gzl-alert gzl-alert-red"/>
        </s:div>
    </h:form>
</ui:composition>